VERSION 5.00
Begin VB.UserControl PrCircle 
   AutoRedraw      =   -1  'True
   ClientHeight    =   1770
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1770
   ScaleHeight     =   118
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   118
   ToolboxBitmap   =   "PrCircle.ctx":0000
End
Attribute VB_Name = "PrCircle"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Private Type LOGBRUSH
    lbStyle As Long
    lbColor As Long
    lbHatch As Long
End Type

Private Type COORD
    x As Long
    y As Long
End Type

Private Declare Function Ellipse Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function FillRgn Lib "gdi32" (ByVal hdc As Long, ByVal hRgn As Long, ByVal hBrush As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function CreatePolygonRgn Lib "gdi32" (lpPoint As Any, ByVal nCount As Long, ByVal nPolyFillMode As Long) As Long
Private Declare Function CreateBrushIndirect Lib "gdi32" (lpLogBrush As LOGBRUSH) As Long

'Default Property Values:
Const m_def_PercentVisible = True
Const m_def_Max = 100
Const m_def_Min = 0
Const m_def_Value = 0
Const m_def_ProgressColor = 0
'Property Variables:
Dim m_PercentVisible As Boolean
Dim m_Max As Long
Dim m_Min As Long
Dim m_Value As Long
Dim m_ProgressColor As OLE_COLOR
'Others Constants and Variables:
Dim arrFillRgn() As COORD
Private Const ALTERNATE = 1
Private Const HS_SOLID = 8
Private Const BS_SOLID = 0
Private Const rd = 1.74532925199433E-02 '=3.14/180
Private lWidth&, lHeight&

Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";ProgressCircle"
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor() = New_BackColor
    PropertyChanged "BackColor"
    Draw
End Property

Public Property Get ProgressColor() As OLE_COLOR
Attribute ProgressColor.VB_ProcData.VB_Invoke_Property = ";ProgressCircle"
    ProgressColor = m_ProgressColor
End Property

Public Property Let ProgressColor(ByVal New_ProgressColor As OLE_COLOR)
    m_ProgressColor = New_ProgressColor
    PropertyChanged "ProgressColor"
    Draw
End Property

Public Property Get Percent() As Integer
Attribute Percent.VB_ProcData.VB_Invoke_Property = ";ProgressCircle"
On Error Resume Next
    Percent = Format((m_Value - m_Min) * 100 / _
        (m_Max - m_Min), "0")
End Property

Public Property Get Max() As Long
Attribute Max.VB_ProcData.VB_Invoke_Property = ";ProgressCircle"
    Max = m_Max
End Property

Public Property Let Max(ByVal New_Max As Long)
    m_Max = New_Max
    PropertyChanged "Max"
    Draw
End Property

Public Property Get Min() As Long
Attribute Min.VB_ProcData.VB_Invoke_Property = ";ProgressCircle"
    Min = m_Min
End Property

Public Property Let Min(ByVal New_Min As Long)
    m_Min = New_Min
    PropertyChanged "Min"
    Draw
End Property

Public Property Get Value() As Long
Attribute Value.VB_ProcData.VB_Invoke_Property = ";ProgressCircle"
    Value = m_Value
End Property

Public Property Let Value(ByVal New_Value As Long)
    If New_Value < m_Min Then New_Value = m_Min
    If New_Value > m_Max Then New_Value = m_Max
    m_Value = New_Value
    PropertyChanged "Value"
    Draw
End Property

Public Property Get FontPercent() As Font
Attribute FontPercent.VB_ProcData.VB_Invoke_Property = ";ProgressCircle"
    Set FontPercent = UserControl.Font
End Property

Public Property Set FontPercent(ByVal New_FontPercent As Font)
    Set UserControl.Font = New_FontPercent
    PropertyChanged "FontPercent"
    Draw
End Property

Public Property Get ForeColorPercent() As OLE_COLOR
Attribute ForeColorPercent.VB_ProcData.VB_Invoke_Property = ";ProgressCircle"
    ForeColorPercent = UserControl.ForeColor
End Property

Public Property Let ForeColorPercent(ByVal New_ForeColorPercent As OLE_COLOR)
    UserControl.ForeColor() = New_ForeColorPercent
    PropertyChanged "ForeColorPercent"
    Draw
End Property

Public Property Get PercentVisible() As Boolean
Attribute PercentVisible.VB_ProcData.VB_Invoke_Property = ";ProgressCircle"
    PercentVisible = m_PercentVisible
End Property

Public Property Let PercentVisible(ByVal New_PercentVisible As Boolean)
    m_PercentVisible = New_PercentVisible
    PropertyChanged "PercentVisible"
    Draw
End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_ProgressColor = m_def_ProgressColor
    m_Max = m_def_Max
    m_Min = m_def_Min
    m_Value = m_def_Value
    Set UserControl.Font = Ambient.Font
    m_PercentVisible = m_def_PercentVisible
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    m_ProgressColor = PropBag.ReadProperty("ProgressColor", m_def_ProgressColor)
    m_Max = PropBag.ReadProperty("Max", m_def_Max)
    m_Min = PropBag.ReadProperty("Min", m_def_Min)
    m_Value = PropBag.ReadProperty("Value", m_def_Value)
    Set UserControl.Font = PropBag.ReadProperty("FontPercent", Ambient.Font)
    UserControl.ForeColor = PropBag.ReadProperty("ForeColorPercent", &H80000012)
    m_PercentVisible = PropBag.ReadProperty("PercentVisible", m_def_PercentVisible)
End Sub

Private Sub UserControl_Resize()
    lWidth = ScaleWidth / 2
    lHeight = ScaleHeight / 2
    Draw
End Sub

Private Sub UserControl_Show()
    Draw
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("ProgressColor", m_ProgressColor, m_def_ProgressColor)
    Call PropBag.WriteProperty("Max", m_Max, m_def_Max)
    Call PropBag.WriteProperty("Min", m_Min, m_def_Min)
    Call PropBag.WriteProperty("Value", m_Value, m_def_Value)
    Call PropBag.WriteProperty("FontPercent", UserControl.Font, Ambient.Font)
    Call PropBag.WriteProperty("ForeColorPercent", UserControl.ForeColor, &H80000012)
    Call PropBag.WriteProperty("PercentVisible", m_PercentVisible, m_def_PercentVisible)
End Sub

'All drawing!
Private Sub Draw()
Dim i%, C As Single, S As Single, numPt&, hRgn&, hBrush&, LB As LOGBRUSH
    Cls
    Ellipse hdc, 0, 0, ScaleWidth, ScaleHeight
    Line (lWidth, lHeight)-(lWidth, 0), m_ProgressColor
    numPt = Round(Percent * 3.6, 0)
    ReDim arrFillRgn(numPt + 1)
    
    For i = 0 To numPt
        C = Cos(i * rd)
        S = Sin(i * rd)
        arrFillRgn(i).x = S * lWidth + lWidth
        arrFillRgn(i).y = -C * lHeight + lHeight
    Next i
    arrFillRgn(numPt + 1).x = lWidth
    arrFillRgn(numPt + 1).y = lHeight
    
    hRgn = CreatePolygonRgn(arrFillRgn(1), numPt + 1, ALTERNATE)
    LB.lbColor = m_ProgressColor
    LB.lbHatch = HS_SOLID
    LB.lbStyle = BS_SOLID
    
    hBrush = CreateBrushIndirect(LB)

    FillRgn hdc, hRgn, hBrush
    DeleteObject hRgn
    DeleteObject hBrush
    
    If m_PercentVisible Then
        Dim strPercent$
        strPercent = Str(Percent) & " %"
        CurrentX = (ScaleWidth - TextWidth(strPercent)) / 2
        CurrentY = (ScaleHeight - TextHeight(strPercent)) / 2
        Print strPercent
    End If
    Refresh
End Sub

